
//--------------------------------------------------------------------------------------
// File: PointSprite.fx
// position, WVPBuffer
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
// Constant Buffer Variables
//--------------------------------------------------------------------------------------
cbuffer WVPBuffer : register( b0 )
{
	matrix world;
	matrix view;
	matrix projection;
	float2 ParticleSize;  // p[eBN̑傫
	float2 dummy;
}

//texture
Texture2D tex2d : register( t0 );
SamplerState samp : register( s0 );


//--------------------------------------------------------------------------------------

struct PS_INPUT
{
    float4 pos : SV_POSITION;
    float2 tex : TEXTURE;         // eNX`W
};


struct PS_INPUT_point
{
    float4 pos : SV_POSITION;
};

//--------------------------------------------------------------------------------------
// Vertex Shader
//--------------------------------------------------------------------------------------
float3 VS( float3 pos : POSITION)  : GS_POSITION
{
	return pos;
}

PS_INPUT_point VS_point( float3 pos : POSITION ){
	PS_INPUT_point output;
	output.pos = float4(pos, 1.0f);
    output.pos = mul( output.pos, world );
    output.pos = mul( output.pos, view );
    output.pos = mul( output.pos, projection );
    return output;
}

//--------------------------------------------------------------------------------------
// Geometry Shader
//--------------------------------------------------------------------------------------
[maxvertexcount(4)]
void GS( point float3 input[1] : GS_POSITION,
             inout TriangleStream<PS_INPUT> ParticleStream )
{
	
	float4 pos = float4(input[0], 1.0);
	pos = mul( pos, world );
    pos = mul( pos, view );
    
    
    float4 posLT = pos + float4(-ParticleSize.x,  ParticleSize.y, 0.0, 0.0) * pos.w;
    float4 posLB = pos + float4(-ParticleSize.x, -ParticleSize.y, 0.0, 0.0) * pos.w;
    float4 posRT = pos + float4( ParticleSize.x,  ParticleSize.y, 0.0, 0.0) * pos.w;
    float4 posRB = pos + float4( ParticleSize.x, -ParticleSize.y, 0.0, 0.0) * pos.w;
    
    // ̓_̈ʒu(ˉeWn)vZďo.
    PS_INPUT output;
    output.pos = mul(posLT, projection);
    output.tex = float2(0.0, 0.0);
    ParticleStream.Append(output);

    // E̓_̈ʒu(ˉeWn)vZďo.
    output.pos = mul(posRT, projection);
    output.tex = float2(1.0, 0.0);
    ParticleStream.Append(output);

    // ̓_̈ʒu(ˉeWn)vZďo.
    output.pos = mul(posLB, projection);
    output.tex = float2(0.0, 1.0);
    ParticleStream.Append(output);

    // E̓_̈ʒu(ˉeWn)vZďo.
    output.pos = mul(posRB, projection);
    output.tex = float2(1.0, 1.0);
    ParticleStream.Append(output);
/*

    float4 posLT = float4(-0.5, 0.5, 0.0, 1.0);
    float4 posLB = float4(-0.5, -0.5, 0.0, 1.0);
    float4 posRT = float4( 0.5, 0.5, 0.0, 1.0);
    float4 posRB = float4( 0.5, -0.5, 0.0, 1.0);
    
    
    // ̓_̈ʒu(ˉeWn)vZďo.
    PS_INPUT output;
    output.pos = posLT;
    output.tex = float2(0.0,0.0);
    ParticleStream.Append(output);

    // E̓_̈ʒu(ˉeWn)vZďo.
    output.pos = posRT;
    output.tex = float2(1.0,0.0);
    ParticleStream.Append(output);

    // ̓_̈ʒu(ˉeWn)vZďo.
    PS_INPUT Out1;
    output.pos = posLB;
    output.tex = float2(0.0,1.0);
    ParticleStream.Append(output);

    // E̓_̈ʒu(ˉeWn)vZďo.
    output.pos = posRB;
    output.tex = float2(1.0,1.0);
    ParticleStream.Append(output);
*/
    ParticleStream.RestartStrip();
    
}

//--------------------------------------------------------------------------------------
// Pixel Shader
//--------------------------------------------------------------------------------------

float4 PS( PS_INPUT input ) : SV_Target
{
    return tex2d.Sample( samp, input.tex );  // * vMeshColor;
}

float4 PSsimple( PS_INPUT_point input ) : SV_Target
{
	static const float4 materialColor = {0.7f, 0.7f, 0.7f, 0.3f};
	
    return materialColor;
}